import os
from lxml import etree
from inventory_provider import juniper

def load_config_schema(hostname, ssh_params):
    return juniper._rpc(hostname, ssh_params).get_xnm_information(
        type='xml-schema',
        namespace='junos-configuration')


if __name__ == "__main__":
    from inventory_provider import config
    with open("config.json") as f:
        params = config.load(f)
    # for r in params['routers']:
    #     netconf = _load_netconf(r['hostname'], params['ssh'])
    #     with open(os.path.join(TEST_DATA_DIR, "%s-netconf.xml" % r['hostname']), 'w') as f:
    #         f.write(etree.tostring(netconf, encoding='unicode'))
    # x = dev.rpc.get_software_information()

    hostname = 'mx1.ams.nl.geant.net'
    # hostname = params['routers'][0]['hostname']

    OUTPUT_DIRNAME = os.path.dirname(__file__)
    schema_doc = load_config_schema(hostname, params['ssh'])
    with open(os.path.join(OUTPUT_DIRNAME, 'juniper-netconf.xsd'), 'w') as f:
        f.write(etree.tostring(schema_doc, pretty_print=True).decode('utf-8'))